/*  GTKtalog.
 *  Copyright (C) 1999-2000  Mathieu VILLEGAS
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <stdio.h>
#include <stdlib.h>

#include "data.h"
#include "erreur.h"


unsigned int *desc_list;
unsigned int *desc_free;
unsigned int nb_new;

void remove_desc_doublons()
{
  int i,j,k,nb_new;
  int fin;
  int decal;

  decal = 0;
  nb_new = 0;
  i = 1;
  while(i<nb_descriptions)
    {
      j = 1;
      fin = 0;
      if ((desc_free[i+decal] == 0)||(strlen(descriptions[i+decal]) == 0))
	{
	  desc_list[i+decal] = 0;
	  for(k=i;k<(nb_descriptions -1);k++)
	    {	      
	      descriptions[k] = (char *)realloc(descriptions[k],(strlen(descriptions[k+1]) +1)*sizeof(char));
	      strcpy(descriptions[k],descriptions[k+1]);
	    }
	  nb_descriptions--;
	  decal++;
	  i--; 
	}
      else
	{
	  while(fin == 0)
	    {
	      
	      if(strcmp(descriptions[i],descriptions[j]) == 0)
		{
		  desc_list[i+decal] = j;

		  if (i != j)
		    {
		      for(k=i;k<(nb_descriptions -1);k++)
			{	      
			  descriptions[k] = (char *)realloc(descriptions[k],(strlen(descriptions[k+1]) +1)*sizeof(char));
			  strcpy(descriptions[k],descriptions[k+1]);
			}
		      nb_descriptions--;
		      decal++;
		      i--;
		    }
		  fin = 1;
		}
	      j++;
	    }
	}
      i++;
    }
}


void update_desc_database(Folder *folder)
{
  int i;
  
  folder->description = desc_list[folder->description];
  for(i=0;i<folder->nb_folders;i++)  update_desc_database(&folder->folders[i]);
  for(i=0;i<folder->nb_files;i++) folder->files[i].description = desc_list[folder->files[i].description];
}

void find_free_desc(Folder *folder)
{
  int i;
  
  desc_free[folder->description] = 1;
  for(i=0;i<folder->nb_folders;i++)  find_free_desc(&folder->folders[i]);
  for(i=0;i<folder->nb_files;i++) desc_free[folder->files[i].description] = 1;
}


void clean_description(GtkWidget *w)
{
  int i;
  unsigned int old_nb_desc;
  char data[30];

  if(nb_descriptions > 1)
    {
      old_nb_desc = nb_descriptions;    
      desc_list = NULL;      
      desc_free = NULL;
      desc_list = malloc(nb_descriptions*sizeof(unsigned int));
      desc_free = malloc(nb_descriptions*sizeof(unsigned int));
      for (i=0;i<nb_descriptions;i++)
	{
	  desc_list[i] = 0;
	  desc_free[i] = 0;
	}
      find_free_desc(&racine);
      remove_desc_doublons();
      update_desc_database(&racine);
      
      sprintf(data,"%d useless descriptions",old_nb_desc - nb_descriptions);
      erreur_dialog(w, data, "have been removed!", "Database cleaned");

      if(desc_list != NULL) free(desc_list);
      if(desc_free != NULL)free(desc_free); 
      desc_list = NULL;      
      desc_free = NULL;
    }
}
