/*  GTKtalog.
 *  Copyright (C) 1999-2000  Mathieu VILLEGAS
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <gtk/gtk.h>
#include <time.h>
#include <stdio.h>


extern GtkWidget *date1;
extern GtkWidget *date2;
extern GtkWidget *checkdate1;
extern GtkWidget *checkdate2;
extern int date1checked;
extern int date2checked;
extern unsigned long val_date1;
extern unsigned long val_date2;


GtkWidget *calendar_window1;
GtkWidget *calendar_window2;

void calendar_day_selected_double_click1 (GtkWidget *widget, GtkWidget *data)
{
  char buffer[256];
  struct tm tm;

  memset (&tm, 0, sizeof (tm));
  gtk_calendar_get_date (GTK_CALENDAR(widget), &tm.tm_year, &tm.tm_mon, &tm.tm_mday);
  sprintf(buffer,"%d.%d.%d",tm.tm_mday,tm.tm_mon+1,tm.tm_year);
  gtk_widget_hide(calendar_window1);

  if(date1checked == 0)
    {
      date1checked = 1;
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkdate1), TRUE);
      date1checked = 1;
    }
  val_date1 = tm.tm_year*10000+(tm.tm_mon+1)*100+tm.tm_mday;
  gtk_label_set (GTK_LABEL (date1), buffer);
  gtk_grab_remove(calendar_window1);
}


void show_calendar1(GtkWidget *w, GtkWidget *data)
{
  gtk_widget_show_all(calendar_window1);
  gtk_grab_add(calendar_window1);
}

gint quit_cal1(GtkWidget *w, GtkWidget *data)
{
  gtk_widget_hide(calendar_window1);
  gtk_grab_remove(calendar_window1);
  return TRUE;
}


void open_calendar1(GtkWidget *w, GtkWidget *data)
{
   GtkWidget *calendar;

   calendar_window1 = gtk_window_new (GTK_WINDOW_DIALOG);
   gtk_window_set_title(GTK_WINDOW(calendar_window1), "Double click on a day");
   gtk_window_set_position (GTK_WINDOW (calendar_window1), GTK_WIN_POS_MOUSE);
   gtk_container_border_width (GTK_CONTAINER (calendar_window1), 5);
   gtk_signal_connect(GTK_OBJECT(calendar_window1), "delete_event", 
		     GTK_SIGNAL_FUNC (quit_cal1), 
		     NULL);
   calendar=gtk_calendar_new();
   gtk_container_add( GTK_CONTAINER( calendar_window1), calendar);
   gtk_calendar_display_options (GTK_CALENDAR (calendar), GTK_CALENDAR_SHOW_HEADING|GTK_CALENDAR_SHOW_DAY_NAMES|GTK_CALENDAR_WEEK_START_MONDAY);
   gtk_signal_connect (GTK_OBJECT (calendar), "day_selected_double_click", 
		       GTK_SIGNAL_FUNC (calendar_day_selected_double_click1),
		       GTK_OBJECT(data));
}



void calendar_day_selected_double_click2 (GtkWidget *widget, GtkWidget *data)
{
  char buffer[256];
  struct tm tm;
  memset (&tm, 0, sizeof (tm));
  gtk_calendar_get_date (GTK_CALENDAR(widget), &tm.tm_year, &tm.tm_mon, &tm.tm_mday);
  sprintf(buffer,"%d.%d.%d",tm.tm_mday,tm.tm_mon+1,tm.tm_year);
  gtk_widget_hide(calendar_window2);

  if(date2checked == 0)
    {
      date2checked = 1;//lui et celui deux lignes en dessous sont indispensables!
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkdate2), TRUE);
      date2checked = 1;
    }
  val_date2 = tm.tm_year*10000+(tm.tm_mon+1)*100+tm.tm_mday;
  gtk_label_set (GTK_LABEL (date2), buffer);
  gtk_grab_remove(calendar_window2);
}


gint show_calendar2(GtkWidget *w, GtkWidget *data)
{
  gtk_widget_show_all(calendar_window2);
  gtk_grab_add(calendar_window2);
  return TRUE;
}

void quit_cal2(GtkWidget *w, GtkWidget *data)
{
  gtk_widget_hide(calendar_window2);
  gtk_grab_remove(calendar_window2);
}

void open_calendar2(GtkWidget *w, GtkWidget *data)
{
   GtkWidget *calendar;

   calendar_window2 = gtk_window_new (GTK_WINDOW_DIALOG);
   gtk_window_set_title(GTK_WINDOW(calendar_window2), "Double click on a day");
   gtk_window_set_position (GTK_WINDOW (calendar_window2), GTK_WIN_POS_MOUSE);
   gtk_container_border_width (GTK_CONTAINER (calendar_window2), 5);
   gtk_signal_connect(GTK_OBJECT(calendar_window2), "delete_event", 
		     GTK_SIGNAL_FUNC (quit_cal2), 
		     NULL);

   calendar=gtk_calendar_new();
   gtk_container_add( GTK_CONTAINER( calendar_window2), calendar);
   gtk_calendar_display_options (GTK_CALENDAR (calendar), GTK_CALENDAR_SHOW_HEADING|GTK_CALENDAR_SHOW_DAY_NAMES|GTK_CALENDAR_WEEK_START_MONDAY);
   gtk_signal_connect (GTK_OBJECT (calendar), "day_selected_double_click", 
		       GTK_SIGNAL_FUNC (calendar_day_selected_double_click2),
		       GTK_OBJECT(data));
}
